///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBSHARINGListFoldersContinueError;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `ListFoldersContinueError` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBSHARINGListFoldersContinueError : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBSHARINGListFoldersContinueErrorTag` enum type represents the possible
/// tag states with which the `DBSHARINGListFoldersContinueError` union can
/// exist.
typedef NS_ENUM(NSInteger, DBSHARINGListFoldersContinueErrorTag) {
  /// `cursor` in `DBSHARINGListFoldersContinueArg` is invalid.
  DBSHARINGListFoldersContinueErrorInvalidCursor,

  /// (no description).
  DBSHARINGListFoldersContinueErrorOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBSHARINGListFoldersContinueErrorTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "invalid_cursor".
///
/// Description of the "invalid_cursor" tag state: `cursor` in
/// `DBSHARINGListFoldersContinueArg` is invalid.
///
/// @return An initialized instance.
///
- (instancetype)initWithInvalidCursor;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "invalid_cursor".
///
/// @return Whether the union's current tag state has value "invalid_cursor".
///
- (BOOL)isInvalidCursor;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBSHARINGListFoldersContinueError` union.
///
@interface DBSHARINGListFoldersContinueErrorSerializer : NSObject

///
/// Serializes `DBSHARINGListFoldersContinueError` instances.
///
/// @param instance An instance of the `DBSHARINGListFoldersContinueError` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBSHARINGListFoldersContinueError` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBSHARINGListFoldersContinueError *)instance;

///
/// Deserializes `DBSHARINGListFoldersContinueError` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBSHARINGListFoldersContinueError` API object.
///
/// @return An instantiation of the `DBSHARINGListFoldersContinueError` object.
///
+ (DBSHARINGListFoldersContinueError *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
