///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMDateRangeError;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `DateRangeError` union.
///
/// Errors that can originate from problems in input arguments to reports.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMDateRangeError : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMDateRangeErrorTag` enum type represents the possible tag states
/// with which the `DBTEAMDateRangeError` union can exist.
typedef NS_ENUM(NSInteger, DBTEAMDateRangeErrorTag) {
  /// (no description).
  DBTEAMDateRangeErrorOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMDateRangeErrorTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMDateRangeError` union.
///
@interface DBTEAMDateRangeErrorSerializer : NSObject

///
/// Serializes `DBTEAMDateRangeError` instances.
///
/// @param instance An instance of the `DBTEAMDateRangeError` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMDateRangeError` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMDateRangeError *)instance;

///
/// Deserializes `DBTEAMDateRangeError` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMDateRangeError` API object.
///
/// @return An instantiation of the `DBTEAMDateRangeError` object.
///
+ (DBTEAMDateRangeError *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
